Ginkgo: gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType > Class Template Reference
Linear Operators » Preconditioners | Linear Operators

A Schwarz preconditioner is a simple domain decomposition preconditioner that generalizes the Block Jacobi preconditioner, incorporating options for different local subdomain solvers and overlaps between the subdomains. More...

`#include <ginkgo/core/distributed/preconditioner/schwarz.hpp>`

Inheritance diagram for gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType >:
[legend]
Collaboration diagram for gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType >:
[legend]

## Classes
struct | parameters_type
class | Factory

## Public Types
using | value_type = ValueType
using | index_type = GlobalIndexType
using | local_index_type = LocalIndexType
using | global_index_type = GlobalIndexType
Public Types inherited from gko::EnablePolymorphicAssignment< Schwarz< default_precision, int32, int64 > >
using | result_type

## Public Member Functions
bool | apply_uses_initial_guess () const override
| Return whether the local solvers use the data in x as an initial guess.
const parameters_type & | get_parameters () const
Public Member Functions inherited from gko::EnableLinOp< Schwarz< default_precision, int32, int64 > >
const Schwarz< default_precision, int32, int64 > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Schwarz< default_precision, int32, int64 > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
static auto | build () -> decltype(Factory::create())
static parameters_type | parse (const config::pnode &config, const config::registry &context, const config::type_descriptor &td_for_child=config::make_type_descriptor< ValueType, LocalIndexType, GlobalIndexType >())
| Create the parameters from the property_tree.

## Friends
class | EnableLinOp< Schwarz >
class | EnablePolymorphicObject< Schwarz, LinOp >

## Detailed Description

template<typename ValueType = default_precision, typename LocalIndexType = int32, typename GlobalIndexType = int64>
class gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType >

A Schwarz preconditioner is a simple domain decomposition preconditioner that generalizes the Block Jacobi preconditioner, incorporating options for different local subdomain solvers and overlaps between the subdomains.

A L1 smoother variant is also available, which updates the local matrix with the sums of the non-local matrix row sums.

See Iterative Methods for Sparse Linear Systems (Y. Saad) for a general treatment and variations of the method.

A Two-level variant is also available. To enable two-level preconditioning, you need to specify a LinOpFactory that can generate a multigrid::MultigridLevel and a solver for the coarse level solution. Currently, only additive coarse correction is supported with an optional weighting between the local and the coarse solutions, for cases when the coarse solutions might tend to overcorrect.

- See Smith, Bjorstad, Gropp, Domain Decomposition, 1996, Cambridge University Press.

Note
  Currently overlap is not supported (TODO).

Template Parameters

  ValueType | precision of matrix element
  LocalIndexType | local integer type of the matrix
  GlobalIndexType | global integer type of the matrix

## Member Function Documentation

## ◆ apply_uses_initial_guess()

template<typename ValueType = default_precision, typename LocalIndexType = int32, typename GlobalIndexType = int64>

bool gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType >::apply_uses_initial_guess | ( |  | ) | const
| override

Return whether the local solvers use the data in x as an initial guess.

Returns
  true when the local solvers use the data in x as an initial guess. otherwise, false.

Note
  TODO: after adding refining step, need to revisit this.

## ◆ parse()

template<typename ValueType = default_precision, typename LocalIndexType = int32, typename GlobalIndexType = int64>

parameters_type gko::experimental::distributed::preconditioner::Schwarz< ValueType, LocalIndexType, GlobalIndexType >::parse | ( | const config::pnode & | config,
|  | const config::registry & | context,
|  | const config::type_descriptor & | td_for_child = config::make_type_descriptor< ValueType, LocalIndexType, GlobalIndexType >() )
| static

Create the parameters from the property_tree.

Because this is directly tied to the specific type, the value/index type settings within config are ignored and type_descriptor is only used for children objects.

Parameters

  config | the property tree for setting
  context | the registry
  td_for_child | the type descriptor for children objects. The default uses the value/local/global index type of this class.

Returns
  parameters

The documentation for this class was generated from the following file:

- ginkgo/core/distributed/preconditioner/schwarz.hpp